/* $Id: asmeffect.S,v 1.1 2007-12-29 00:51:46 chris Exp $
 *
 * assembler version of "effect"
 *
 * Written by Christian Groessler <chris@groessler.org>
 * This program is in the public domain.
 */

/* void make_effect(unsigned short *screen_buf); */

#define SCREENBUFSIZE 16384

	name	"asmeffect.S"
	segm

	.text
	even
global	_make_effect

_make_effect:

	pushl	@sp,rr12
#ifdef __STD_CALL__
	ldl	rr12,rr14(#8)		! screen_buf
#else
	ldl	rr12,rr6		! screen_buf
#endif

	sub	r15,#24
	ldm	@sp,r0,#12		! save all registers on the stack

	ldl	rr10,#0x03000000	! screen

! rr10 points to screen memory
! rr12 points to new image

	ldk	r2,#1			! positive mask
	ld	r3,#0xfffe		! negative mask
	ld	r4,#16			! loop over 16 bits

loop:	ld	r5,#SCREENBUFSIZE/2
	clr	r6
loop2:	ld	r0,rr10(r6)		! get word from screen memory
	and	r0,r3
	ld	r1,rr12(r6)		! get word from new image
	and	r1,r2
	or	r0,r1
	ld	rr10(r6),r0		! write new screen memory
	inc	r6,#2
	djnz	r5,loop2

! one bit done

	rl	r2,#1			! adjust mask
	rl	r3,#1			! "  "  "  "
	djnz	r4,loop

	ldm	r0,@sp,#12		! restore registers
	add	r15,#24

	popl	rr12,@sp
	ret

	.end
